/* OPCL.c */

#include "EV3.h"
#include "OPCL.h"

/*=====================================================================
  J\֐
  =====================================================================*/
/*
 * Door
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
void Door(struct Door *this)
{
	/* l */
	this->m_CLSL = OFF;
	this->m_CLST = OFF;
	this->m_OPSL = OFF;
	this->m_OPST = OFF;
	this->p_CloserSlow = &this->m_CLSL;
	this->p_CloserStop = &this->m_CLST;
	this->p_OpennerSlow = &this->m_OPSL;
	this->p_OpennerStop = &this->m_OPST;
	/* Sleepp */
	this->fstop = OFF;
	this->p_fstop = &this->fstop;
	this->fmove = OFF;
	this->p_fmove = &this->fmove;
	
	/* ߂ */
	return;
}

/*
 * OpenMotor
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
void OpenMotor(struct OpenMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnOpenMotor
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* J */
void OnOpenMotor(struct OpenMotor *this, struct Door DR)
{
	if(*DR.p_OpennerStop == ON){
		/* Sleepp */
		if(*DR.p_fstop == OFF){
			*DR.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			printf("STOP܂\n");
		}
	}
	else if(*DR.p_OpennerSlow == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'o');
			printf("OPEN܂\n");
		}
	}
	else if(*DR.p_CloserSlow == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'O');
			printf("OPEN܂\n");
		}
	}
	else if(*DR.p_CloserStop == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'o');
			printf("OPEN܂\n");
		}
	}
	else if(*DR.p_CloserStop == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'h');
			printf("J܂\n");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * CloseMotor
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
void CloseMotor(struct CloseMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnCloseMotor
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/*  */
void OnCloseMotor(struct CloseMotor *this, struct Door DR)
{
	if(*DR.p_CloserStop == ON){
		/* Sleepp */
		if(*DR.p_fstop == OFF){
			*DR.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			printf("STOP܂\n");
		}
	}
	else if(*DR.p_CloserSlow == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'c');
			printf("CLOSE܂\n");
		}
	}
	else if(*DR.p_OpennerSlow == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'C');
			printf("CLOSE܂\n");
		}
	}
	else if(*DR.p_OpennerStop == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'c');
			printf("CLOSE܂\n");
		}
	}
	else if(*DR.p_OpennerStop == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 't');
			printf("܂\n");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * OnStopCloseMotor
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* ~ */
void OnStopCloseMotor(struct CloseMotor *this, struct Door DR)
{
	if(*DR.p_OpennerStop == ON){
		/* Sleepp */
		if(*DR.p_fstop == OFF){
			*DR.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			printf("STOP܂\n");
		}
	}
	else{
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'h');
			printf("J܂\n");
		}
	}
	
	/* ߂ */
	return;
}


/*
 * WaitDoorChangeLog
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void WaitDoorChangeLog(struct WaitDoorChangeLog *this)
{
	this->p_chTurnOpen = &this->chTurnOpen;
	this->p_strLimit = &this->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitDoorChangeLog
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitDoorChangeLog(struct WaitDoorChangeLog *this, struct Door DR)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserStop, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerStop, DR.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitOpenDoorChangeLog
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnWaitOpenDoorChangeLog(struct WaitDoorChangeLog *this, struct Door DR)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserStop, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerStop, DR.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * Open
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* J */
void Open(struct Door DR, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, struct CTime *p_OpenTO)
{
	/* JmFp */
	struct CFile LF;
	CFile(&LF);
	
	/* ܂ */
	while((*DR.p_OpennerStop == OFF) || (Motor_Read(&LF) != 's'))
	{
		/* J */
		OnOpenMotor(&OPMT, DR);

		/* oߎ */
		/* Sleep */
		Wait_ms(500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitOpenDoorChangeLog(&WDCL, DR);
	}
	/* ݊J */
	printf("JĂ܂\n");
	SetCurrentTime(p_OpenTO);
	SetPermit(p_OpenTO, ON);
	
	/* ߂ */
	return;
}

/*
 * OnWaitCloseDoorChangeLog
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnWaitCloseDoorChangeLog(struct WaitDoorChangeLog *this, struct Door DR)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserStop, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR.p_CloserSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerSlow, DR.p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR.p_OpennerStop, DR.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnCheckTurnOpen
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/* TurnOpenmF */
void OnCheckTurnOpen(struct WaitDoorChangeLog *this, struct Position P, struct Door DR, int *p_TurnOpen)
{
	
	/* f */
	if(TurnOpen_Read(&this->TOF, this->p_chTurnOpen) == NG) exit(1);

	if(*this->p_chTurnOpen == 'o'){
		this->tmp = ON;
	}
	else if(*this->p_chTurnOpen == 'Y'){
		if(*P.p_UpperStop == ON){
			/* ]J */
			this->tmp = ON;
		}
		else{
			printf("Ă͉̊Kɂ܂\n");
			if(TurnOpen_Write(&this->TOF, 'N') == NG) exit(1);
			this->tmp = OFF;
		}
	}
	else if(*this->p_chTurnOpen == 'y'){
		if(*P.p_UnderStop == ON){
			/* ]J */
			this->tmp = ON;
		}
		else{
			printf("Ă͏̊Kɂ܂\n");
			if(TurnOpen_Write(&this->TOF, 'N') == NG) exit(1);
			this->tmp = OFF;
		}
	}
	else{
		this->tmp = OFF;
	}
	
	Checkfmove(p_TurnOpen, DR.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * Close
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
/*  */
void Close(struct Position P, struct Door DR, struct CloseMotor CLMT, int *p_TurnOpen, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, struct CTime *p_OpenTO)
{
	/* Whilep */
	int WhileFlag = ON;

	/* fp */
	struct CFile TOF;

	/* mFp */
	struct CFile LF;

	/*  */
	CFile(&TOF);
	CFile(&LF);

	/* f */
	if(PermitTurnOpen_Write(&TOF, 'o') == NG) exit(1);

	/* While𔲂o */
	if(*DR.p_CloserStop == ON){
		WhileFlag = OFF;
	}
	
	/* ܂ */
	while(WhileFlag == ON)
	{
		/*  */
		OnCloseMotor(&CLMT, DR);

		/* oߎ */
		/* Sleep */
		Wait_ms(500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitCloseDoorChangeLog(&WDCL, DR);

    /* TurnOpenmF */
    OnCheckTurnOpen(&WDCL, P, DR, p_TurnOpen);
			
		/* f */
		if(*p_TurnOpen == ON){
			/* ~ */
			OnStopCloseMotor(&CLMT, DR);
			/* J */
			Open(DR, OPMT, WDCL, p_OpenTO);
			/* sWhile𔲂o */
			WhileFlag = OFF;
		}
		else if(*p_TurnOpen == OFF){
			if(*DR.p_CloserStop == OFF){
				WhileFlag = ON;
			}
			/* While𔲂o */
			else if((*DR.p_CloserStop == ON)
				&& (Motor_Read(&LF) == 's')){
				WhileFlag = OFF;
			}
		}
	}
	/* sȊO */
	if(*p_TurnOpen == OFF){
		/* ݕ */
		printf("Ă܂\n");
	}

	/* fI */
	if(PermitTurnOpen_Write(&TOF, 'N') == NG) exit(1);

	/* fI */
	if(TurnOpen_Write(&TOF, 'N') == NG) exit(1);

	/* ߂ */
	return;
}
