/* OPCL.c */

#include "EV4.h"
#include "OPCL.h"

/*=====================================================================
  J\֐
  =====================================================================*/
/*
 * Door
 */
void Door(struct Door *this)
{
	/* l */
	this->m_CLSL = OFF;
	this->m_CLST = OFF;
	this->m_OPSL = OFF;
	this->m_OPST = OFF;
	this->p_CloserSlow = &this->m_CLSL;
	this->p_CloserStop = &this->m_CLST;
	this->p_OpennerSlow = &this->m_OPSL;
	this->p_OpennerStop = &this->m_OPST;
	/* Sleepp */
	this->fstop = OFF;
	this->p_fstop = &this->fstop;
	this->fmove = OFF;
	this->p_fmove = &this->fmove;
	
	/* ߂ */
	return;
}

/*
 * OpenMotor
 */
void OpenMotor(struct OpenMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnOpenMotor
 */
/* J */
void OnOpenMotor(struct OpenMotor *this, struct Door DR)
{
	if(*DR.p_OpennerStop == ON){
		/* Sleepp */
		if(*DR.p_fstop == OFF){
			*DR.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			PrintF(Panel, "STOP");
		}
	}
	else if(*DR.p_OpennerSlow == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'o');
			PrintF(Panel, "OPEN");
		}
	}
	else if(*DR.p_CloserSlow == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'O');
			PrintF(Panel, "OPEN Speedy");
		}
	}
	else if(*DR.p_CloserStop == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'o');
			PrintF(Panel, "OPEN");
		}
	}
	else if(*DR.p_CloserStop == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'h');
			PrintF(Panel, "OPEN Start");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * CloseMotor
 */
void CloseMotor(struct CloseMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnCloseMotor
 */
/*  */
void OnCloseMotor(struct CloseMotor *this, struct Door DR)
{
	if(*DR.p_CloserStop == ON){
		/* Sleepp */
		if(*DR.p_fstop == OFF){
			*DR.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			PrintF(Panel, "STOP");
		}
	}
	else if(*DR.p_CloserSlow == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'c');
			PrintF(Panel, "CLOSE");
		}
	}
	else if(*DR.p_OpennerSlow == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'C');
			PrintF(Panel, "CLOSE Speedy");
		}
	}
	else if(*DR.p_OpennerStop == OFF){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'c');
			PrintF(Panel, "CLOSE");
		}
	}
	else if(*DR.p_OpennerStop == ON){
		/* Sleepp */
		*DR.p_fstop = OFF;
		if(*DR.p_fmove == OFF){
			*DR.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 't');
			PrintF(Panel, "CLOSE Start");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * WaitDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void WaitDoorChangeLog(struct WaitDoorChangeLog *this)
{
	this->p_chTurnOpen = &this->chTurnOpen;
	this->p_strLimit = &this->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitOpenDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitOpenDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitCloseDoorChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitCloseDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[4] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserStop, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[5] == 'y') ? ON : OFF;
	Checkfmove(DR->p_CloserSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[6] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerSlow, DR->p_fmove, this->tmp);
	this->tmp = (this->strLimit[7] == 'y') ? ON : OFF;
	Checkfmove(DR->p_OpennerStop, DR->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * Open
 */
/* J */
void Open(struct Door *DR, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, struct Handle_Thread *th)
{
	/* JmFp */
	struct CFile LF;
	
	/* Wait_msp */
	struct CTime T;
	
	/*  */
	CFile(&LF);
	CTime(&T, th);
	
	/* ܂ */
	if(*DR->p_OpennerStop == OFF)
	{
		/* J */
		OnOpenMotor(&OPMT, *DR);

		/* oߎ */
		/* Sleep */
		Wait_ms(&T, 500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitOpenDoorChangeLog(&WDCL, DR);
	}
	else if(Motor_Read(&LF) == 's')
	{
		/* ݊J */
		PrintF(Panel, "Opened");
	}
	
	/* ߂ */
	return;
}

/*
 * Close
 */
/*  */
void Close(struct Door *DR, struct CloseMotor CLMT, struct WaitDoorChangeLog WDCL, struct Handle_Thread *th)
{
	/* mFp */
	struct CFile LF;
	
	/* Wait_msp */
	struct CTime T;

	/*  */
	CFile(&LF);
	CTime(&T, th);

	/* ܂ */
	if(*DR->p_CloserStop == OFF)
	{	
		/*  */
		OnCloseMotor(&CLMT, *DR);
		
		/* oߎ */
		/* Sleep */
		Wait_ms(&T, 500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitCloseDoorChangeLog(&WDCL, DR);
	}	
	else if(Motor_Read(&LF) == 's')
	{
		/* ݕ */
		PrintF(Panel, "Closed");
	}

	/* ߂ */
	return;
}
