/* TIME.c */

#include "EV4.h"
#include "TIME.h"

/*=====================================================================
  Xbh\֐
  =====================================================================*/
/* Ԃ\Oϐ錾 */
double woviClock;

/* [Xbh` */
#ifdef USE_THREAD

/* wovip[CX^X錾 */
struct Handle_Thread woviThread[THREADSIZE];

/* Xbhvoid Sleep(int ms)̑p */
void nextRun(struct Handle_Thread *this, int ms)
{
	this->preClock = woviClock;
	this->setClock = (((double) ms) / 1000);
	return;
}

/* Xbh̃RXgN^̑p */
void Thread(struct Thread *this, int id)
{
	int i;
	for(i = 0; i < THREADSIZE; i++)
	{
		if(woviThread[i].preClock == INITCLOCKNO)
		{
			this->p_ThreadID = &woviThread[i];
			woviThread[i].ID = id;
			/* Xbhvoid init(void)̑p */
			Init(&woviThread[i]);
			break;
		}
	}
	return;
}

/* Xbh̃fXgN^̑p */
void Destroy(struct Thread *this)
{
	this->p_ThreadID->ID = NULLTHREADID;
	this->p_ThreadID->preClock = INITCLOCKNO;
	this->p_ThreadID->setClock = 0;
	return;
}

/* Xbhvoid start(void)̑p */
void Start(struct Thread *this)
{
	this->p_ThreadID->preClock = woviClock;
	return;
}

/* Xbhvoid stop(void)̑p */
void Stop(struct Thread *this)
{
	this->p_ThreadID->preClock = STOPCLOCKNO;
	return;
}

/* RunĂԃ^C~O */
void woviRun(void)
{
	int i;
	for(i = 0; i < THREADSIZE; i++)
	{
		if(woviClock >= woviThread[i].preClock + woviThread[i].setClock)
		{
			/* Xbhvoid run(void)̑p */
			Run(&woviThread[i]);
			woviThread[i].preClock = woviClock;
		}
	}
	return;
}

/* wJnOFF */
void woviInit(void)
{
	int i;
	for(i = 0; i < THREADSIZE; i++)
	{
		woviThread[i].ID = NULLTHREADID;
		woviThread[i].preClock = INITCLOCKNO;
		woviThread[i].setClock = 0;
	}
	return;
}

#endif

/*=====================================================================
  ^C}[\֐
  =====================================================================*/
/* ^C}֐ */
void wovi(void)
{
	int i;
#ifdef USE_BCC
	woviClock = clock() / CLOCKS_PER_SEC;
#else
	woviClock += 1.0 / WOVI_PER_MS;
#endif
	if(woviClock >= WOVICLOCKSIZE)
	{
		PrintF(Panel, "\nOVERWOVI");
		woviClock = -WOVICLOCKSIZE;
		for(i = 0; i < THREADSIZE; i++)
		{
			woviThread[i].preClock = 0;
			woviThread[i].setClock = 0;
		}
	}
#ifdef USE_THREAD
	woviRun(); /* Xbĥ߂RunĂԃ^C~O */
#endif
	return;
}

/* ^C}֐ */
void initWOVI(void)
{
	woviClock = -WOVICLOCKSIZE;
#ifdef USE_THREAD
	woviInit(); /* Xbĥ߂̎wJnOFF */
#endif
	return;
}

/* ~b҂֐ */
void setSleep(unsigned int ms)
{
	double start;
	double set;
#ifdef USE_BCC
	start = clock() / CLOCKS_PER_SEC;
#else
	start = woviClock;
#endif
	set = ((double) ms) / 1000;
	while(woviClock < start + set)
	{
#ifdef USE_BCC
		woviClock = clock() / CLOCKS_PER_SEC;
#else
		woviClock += 1.0 / SLEEP_PER_MS;
#endif
	}
	return;
}

/*=====================================================================
  Ԃ\֐
  =====================================================================*/
/*
 * CmyTime
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void CTime(struct CTime *this, struct Handle_Thread *th)
{
	this->TimeTemp = 0;
	this->p_TimeTemp = &this->TimeTemp;
	SetCurrentTime(this);
	this->p_Permit = &this->Permit;
	this->Permit = OFF;
	this->tmpTimeSafety = 0;
	this->th = th;
	
	/* ߂ */
	return;
}

/*
 * SetCurrentTime
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void SetCurrentTime(struct CTime *this)
{
	this->p_TimeTemp = &this->TimeTemp;
#ifdef USE_BCC
	*this->p_TimeTemp = clock();
#else
	*this->p_TimeTemp = woviClock;
#endif
	
	/* ߂ */
	return;
}

/*
 * GetCurrentTime
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int GetCurrentTime(struct CTime *this)
{
	this->p_TimeTemp = &this->TimeTemp;
#ifdef USE_BCC
	return ((clock() - *this->p_TimeTemp)/CLOCKS_PER_SEC);
#else
	return ((woviClock - *this->p_TimeTemp)/(SLEEP_PER_MS * 1000));
#endif
}

/*
 * WaitSecond
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void WaitSecond(struct CTime *this, int num_Second)
{
	nextRun(this->th, (num_Second * 1000));	
	/* ߂ */
	return;
}

/*
 * SetPermit
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void SetPermit(struct CTime *this, int P)
{
	this->p_Permit = &this->Permit;
	if(P == ON) this->Permit = ON;
	else if(P == OFF) this->Permit = OFF;
	
	/* ߂ */
	return;
}

/*
 * GetPermit
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int GetPermit(struct CTime *this)
{
	this->p_Permit = &this->Permit;
	return this->Permit;
}

/*
 * Checkfmove
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Checkfmove(int *p_check, int *p_fmove, int tmp)
{
	if(*p_check != tmp){
		*p_fmove = OFF;
		*p_check = tmp;
	}
	
	/* ߂ */
	return;
}

/*
 * Wait_ms
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void	Wait_ms(struct CTime *this, int num){

	nextRun(this->th, num);	
	/* ߂ */
	return;
}
